---
title: Range.selectNodeContents()
slug: Web/API/Range/selectNodeContents
tags:
  - API
  - DOM
  - Method
  - Range
  - Reference
---
<div>{{ApiRef("DOM")}}</div>

<p>The <strong><code>Range.selectNodeContents()</code></strong> method sets the {{ domxref("Range") }} to contain the contents of a {{ domxref("Node") }}.</p>

<p>The parent <code>Node</code> of the start and end of the <code>Range</code> will be the reference node. The <code>startOffset</code> is 0, and the <code>endOffset</code> is the number of child <code>Node</code>s or number of characters contained in the reference node.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>range</em>.selectNodeContents(<em>referenceNode</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>referenceNode</code></dt>
 <dd>The {{ domxref("Node") }} whose contents will be selected within a {{ domxref("Range") }}.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">range = document.createRange();
referenceNode = document.getElementsByTagName("div")[0];
range.selectNodeContents(referenceNode);
</pre>

<h3 id="Live_sample">Live sample</h3>

<p>This example lets the user select and deselect a paragraph with buttons. {{domxref("Document.createRange()")}}, <code>Range.selectNodeContents()</code>, and {{domxref("Selection.addRange()")}} are used to select the content. {{domxref("Window.getSelection()")}} and {{domxref("Selection.removeAllRanges()")}} are used to deselect it.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;p id="p"&gt;&lt;b&gt;Use the buttons below&lt;/b&gt; to select or deselect the contents of this paragraph.&lt;/p&gt;
&lt;button id="select-button"&gt;Select paragraph&lt;/button&gt;
&lt;button id="deselect-button"&gt;Deselect paragraph&lt;/button&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js">const p = document.getElementById('p');
const selectButton = document.getElementById('select-button');
const deselectButton = document.getElementById('deselect-button');

selectButton.addEventListener('click', e =&gt; {
  // Clear any current selection
  const selection = window.getSelection();
  selection.removeAllRanges();

  // Select paragraph
  const range = document.createRange();
  range.selectNodeContents(p);
  selection.addRange(range);
});

deselectButton.addEventListener('click', e =&gt; {
  const selection = window.getSelection();
  selection.removeAllRanges();
});</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Live_sample")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-range-selectnodecontents', 'Range.selectNodeContents()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'ranges.html#Level2-Range-method-selectNodeContents', 'Range.selectNodeContents()')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Range.selectNodeContents")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/DOM/DOM_Reference">The DOM interfaces index</a></li>
</ul>
